require "blue/unicorn/version"
require "blue/unicorn/capistrano/integration"

module Blue
  module Unicorn

    Blue::Gems.require('blue-unicorn')

    def self.configure
      Blue.configure({
        :unicorn => {}
      })
    end

    def unicorn(options = {})
      file "/etc/init.d/unicorn",
        :ensure  => :present,
        :mode    => '744',
        :owner   => Blue.config.user,
        :content => template(File.join(File.dirname(__FILE__), '..', '..', 'templates', 'unicorn.init.erb'), binding)

      file Blue::Unicorn.cfg_path,
        :ensure  => :present,
        :mode    => '744',
        :owner   => Blue.config.user,
        :content => template(File.join(File.dirname(__FILE__), '..', '..', 'templates', 'unicorn.cfg.erb'), binding)

      if Blue.const_defined?(:Monit)
        file "/etc/monit/conf.d/unicorn.conf",
          :ensure  => :present,
          :mode    => '700',
          :backup  => false,
          :content => template(File.join(File.dirname(__FILE__), '..', '..', 'templates', 'monit.conf.erb'), binding),
          :notify  => service('monit')
      elsif Blue.const_defined?(:God)
        # Define this yo'self homie.
      end
    end

    def self.pid_path
      File.join(Blue.rails_current, 'pids/unicorn.master.pid')
    end

    def self.cfg_path
      File.join(Blue.shared_path, 'config/unicorn.cfg')
    end

    def self.included(klass)
      klass.add_role(:app)
      klass.add_role(:unicorn)
      klass.class_eval do
        recipe :unicorn
      end
    end
  end
end

Blue::Unicorn.configure

