module Blue
  module Unicorn
    module Capistrano
      module Integration
        def self.load(capistrano_config)
          capistrano_config.load do

            namespace :blue do
              namespace :unicorn do
                desc "Trigger Unicorn restarts"
                task :restart do
                  run "/etc/init.d/unicorn restart"
                end
              end
            end

            after 'deploy:create_symlink', 'blue:unicorn:restart'
          end
        end
      end
    end
  end
end

if Capistrano::Configuration.instance
  Blue::Unicorn::Capistrano::Integration.load(Capistrano::Configuration.instance)
end

